http://www.voidcn.com/article/p-tewahutf-pe.html
Ei=ki×E1+(1−ki−ei)×Efatheri+1−ki−ei
Ei=ki×E1+1−ki−eim×Efatheri+1−ki−eim×∑j∈soniEj+1−ki−ei
然后我们发现所有的
Ai=ki
Bi=1−ki−ei
Ci=1−ki−ei
∑j∈soniEj=∑j∈soniAj×E1+Bj×Ei+Cj
(1−1−ki−eim×∑j∈soniBj)×Ei=(ki+1−ki−eim×∑j∈soniAj)×E1+1−ki−eim×Efatheri+1−ki−ei+1−ki−eim×∑j∈soniCj
Ai=ki+1−ki−eim×∑j∈soniAj1−1−ki−eim×∑j∈soniBj
Bi=1−ki−eim1−1−ki−eim×∑j∈soniBj
Ci=1−ki−ei+1−ki−eim×∑j∈soniCj1−1−ki−eim×∑j∈soniBj
从叶子节点往上递推即可
When wake up, lxhgww find himself in a huge maze.
The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.
Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room).
What is the expect number of tunnels he go through before he find the exit?
The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.
Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room).
What is the expect number of tunnels he go through before he find the exit?
Input
First line is an integer T (T ≤ 30), the number of test cases.
At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.
Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.
Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.
At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.
Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.
Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.
Output
For each test case, output one line “Case k: ”. k is the case id, then the expect number of tunnels lxhgww go through before he exit. The answer with relative error less than 0.0001 will get accepted. If it is not possible to escape from the maze, output “impossible”.
Sample Input
3 3 1 2 1 3 0 0 100 0 0 100 3 1 2 2 3 0 0 100 0 0 100 6 1 2 2 3 1 4 4 5 4 6 0 0 20 30 40 30 50 50 70 10 20 60
Sample Output
Case 1: 2.000000
Case 2: impossible
Case 3: 2.895522
题意:一棵树,从点1出发,每到另一个节点有3种可能:
1.被杀死,回到点1,概率为ki
2.逃出去,走出迷宫,概率为ei
3.接着走,概率等分
求走出去的步数期望。
设 E[i]表示在结点i处,要走出迷宫所要走的边数的期望。E[1]即为所求。
叶子结点:
E[i] = ki*E[1] + ei*0 + (1-ki-ei)*(E[father[i]] + 1);
= ki*E[1] + (1-ki-ei)*E[father[i]] + (1-ki-ei);
非叶子结点:(m为与结点相连的边数)
E[i] = ki*E[1] + ei*0 + (1-ki-ei)/m*( E[father[i]]+1 + ∑( E[child[i]]+1 ) );
= ki*E[1] + (1-ki-ei)/m*E[father[i]] + (1-ki-ei)/m*∑(E[child[i]]) + (1-ki-ei);
设对每个结点:E[i] = Ai*E[1] + Bi*E[father[i]] + Ci;
对于非叶子结点i,设j为i的孩子结点,则
∑(E[child[i]]) = ∑E[j]
= ∑(Aj*E[1] + Bj*E[father[j]] + Cj)
= ∑(Aj*E[1] + Bj*E[i] + Cj)
带入上面的式子得
(1 - (1-ki-ei)/m*∑Bj)*E[i] = (ki+(1-ki-ei)/m*∑Aj)*E[1] + (1-ki-ei)/m*E[father[i]] + (1-ki-ei) + (1-ki-ei)/m*∑Cj;
由此可得
Ai = (ki+(1-ki-ei)/m*∑Aj) / (1 - (1-ki-ei)/m*∑Bj);
Bi = (1-ki-ei)/m / (1 - (1-ki-ei)/m*∑Bj);
Ci = ( (1-ki-ei)+(1-ki-ei)/m*∑Cj ) / (1 - (1-ki-ei)/m*∑Bj);
对于叶子结点
Ai = ki;
Bi = 1 - ki - ei;
Ci = 1 - ki - ei;
从叶子结点开始,直到算出 A1,B1,C1;
E[1] = A1*E[1] + B1*0 + C1;
所以
E[1] = C1 / (1 - A1);
若 A1趋近于1则无解...
const double eps=1e-9;//这里1e-8会WA。设为1e-9和1e-10可以 double k[MAXN],e[MAXN]; double A[MAXN],B[MAXN],C[MAXN]; vector<int>vec[MAXN];//存树 bool dfs(int t,int pre)//t的根结点是pre { int m=vec[t].size();//点t的度 A[t]=k[t]; B[t]=(1-k[t]-e[t])/m; C[t]=1-k[t]-e[t]; double tmp=0; for(int i=0;i<m;i++) { int v=vec[t][i]; if(v==pre)continue; if(!dfs(v,t))return false; A[t]+=(1-k[t]-e[t])/m*A[v]; C[t]+=(1-k[t]-e[t])/m*C[v]; tmp+=(1-k[t]-e[t])/m*B[v]; } if(fabs(tmp-1)<eps)return false; A[t]/=(1-tmp); B[t]/=(1-tmp); C[t]/=(1-tmp); return true; } int main() { // freopen("in.txt","r",stdin); // freopen("out.txt","w",stdout); int T; int n; int u,v; int iCase=0; scanf("%d",&T); while(T--) { iCase++; scanf("%d",&n); for(int i=1;i<=n;i++)vec[i].clear(); for(int i=1;i<n;i++) { scanf("%d%d",&u,&v); vec[u].push_back(v); vec[v].push_back(u); } for(int i=1;i<=n;i++) { scanf("%lf%lf",&k[i],&e[i]); k[i]/=100; e[i]/=100; } printf("Case %d: ",iCase); if(dfs(1,-1)&&fabs(1-A[1])>eps) { printf("%.6lf\n",C[1]/(1-A[1])); } else printf("impossible\n"); }http://mlz000.logdown.com/posts/220880-hdu-4035-maze-probability-dp
1:i为叶子节点
2:i非叶子节点
m为与i节点相连的边数
然后我们发现所有的Ei 都可以表示成Ai×E1+Bi×Efatheri+Ci 的形式
于是i为叶子节点时
i非叶子节点时
从叶子节点往上递推即可
double A[N],B[N],C[N],k[N],e[N]; vector<int>edge[N]; void dfs(int u,int f){ double a=0.0,b=0.0,c=0.0; int m=0; for(int i=0;i<edge[u].size();++i){ int v=edge[u][i]; if(v==f) continue; dfs(v,u); a+=A[v]; b+=B[v]; c+=C[v]; ++m; } if(f) ++m; double p=(1-k[u]-e[u])/m; A[u]=(k[u]+p*a)/(1-p*b); B[u]=p/(1-p*b); C[u]=(1-k[u]-e[u]+p*c)/(1-p*b); } int main(){ int T,n; scanf("%d",&T); for(int tt=1;tt<=T;++tt){ printf("Case %d: ",tt); scanf("%d",&n); for(int i=1;i<N;++i) edge[i].clear(),A[i]=0,B[i]=0,C[i]=0; for(int i=1,x,y;i<n;++i){ scanf("%d%d",&x,&y); edge[x].push_back(y); edge[y].push_back(x); } for(int i=1;i<=n;++i) scanf("%lf%lf",&k[i],&e[i]),k[i]/=100.0,e[i]/=100.0; dfs(1,0); if(fabs(1-A[1])<eps) printf("impossible\n"); else printf("%.6lf\n",C[1]/(1-A[1])); } return 0; }